VERSION 5.00
Begin VB.Form frmLogin 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Logins"
   ClientHeight    =   3480
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   6600
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3480
   ScaleWidth      =   6600
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdClose 
      Caption         =   "Abbrechen"
      Height          =   375
      Left            =   3000
      TabIndex        =   15
      Top             =   3000
      Width           =   1695
   End
   Begin VB.Frame Frame4 
      Caption         =   "Aktionen und Stati"
      Height          =   1935
      Left            =   4200
      TabIndex        =   13
      Top             =   240
      Width           =   2295
      Begin VB.ListBox lstStatus 
         Height          =   1425
         Left            =   240
         TabIndex        =   14
         Top             =   360
         Width           =   1815
      End
   End
   Begin VB.CommandButton cmdGoOn 
      Caption         =   "Weiter >>"
      Height          =   375
      Left            =   4800
      TabIndex        =   12
      Top             =   3000
      Width           =   1695
   End
   Begin VB.CheckBox chkSystemMDW 
      Caption         =   "System-MDW verwenden"
      Height          =   255
      Left            =   1920
      TabIndex        =   11
      Top             =   2280
      Value           =   1  'Checked
      Width           =   2175
   End
   Begin VB.Frame Frame3 
      Caption         =   "Prompt"
      Height          =   1095
      Left            =   120
      TabIndex        =   7
      Top             =   1440
      Width           =   1575
      Begin VB.OptionButton optPromptShow 
         Caption         =   "Mit"
         Height          =   255
         Left            =   240
         TabIndex        =   9
         Top             =   360
         Width           =   1095
      End
      Begin VB.OptionButton optPropmtNot 
         Caption         =   "Ohne"
         Height          =   255
         Left            =   240
         TabIndex        =   8
         Top             =   720
         Value           =   -1  'True
         Width           =   1095
      End
   End
   Begin VB.Frame Frame2 
      Caption         =   "Verbinden ber"
      Height          =   1935
      Left            =   1920
      TabIndex        =   3
      Top             =   240
      Width           =   2175
      Begin VB.CommandButton cmdOpenUdl 
         Caption         =   "UDL-Datei"
         Height          =   375
         Left            =   240
         TabIndex        =   6
         Top             =   1320
         Width           =   1695
      End
      Begin VB.CommandButton cmdOpenConnString 
         Caption         =   "ConnectionString"
         Height          =   375
         Left            =   240
         TabIndex        =   5
         Top             =   840
         Width           =   1695
      End
      Begin VB.CommandButton cmdOpenParam 
         Caption         =   "Parameter"
         Height          =   375
         Left            =   240
         TabIndex        =   4
         Top             =   360
         Width           =   1695
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "Optionen"
      Height          =   1095
      Left            =   120
      TabIndex        =   0
      Top             =   240
      Width           =   1575
      Begin VB.OptionButton optConnAsync 
         Caption         =   "Asyncron"
         Height          =   255
         Left            =   240
         TabIndex        =   2
         Top             =   720
         Width           =   1095
      End
      Begin VB.OptionButton optConnSyncron 
         Caption         =   "Syncron"
         Height          =   255
         Left            =   240
         TabIndex        =   1
         Top             =   360
         Value           =   -1  'True
         Width           =   1095
      End
   End
   Begin VB.Label Label1 
      BorderStyle     =   1  'Fixed Single
      Caption         =   "Datenbankpasswort = ""test"" User-Id = ""florianr"" User-Passwort = ""flo"""
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H000000FF&
      Height          =   615
      Left            =   120
      TabIndex        =   10
      Top             =   2760
      Width           =   2655
   End
End
Attribute VB_Name = "frmLogin"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit


Dim WithEvents CnLocal As ADODB.Connection
Attribute CnLocal.VB_VarHelpID = -1

Private Sub cmdClose_Click()
    Unload Me
End Sub

Private Sub cmdGoOn_Click()
Dim RsTemp As ADODB.Recordset

    ' Lokale Connection (wegen den Events) wird an die globale bergeben.
    Set Cn = New ADODB.Connection
    Cn.Mode = adModeShareDenyNone
    Cn.CursorLocation = adUseClient
    Cn.ConnectionString = CnLocal.ConnectionString
    Cn.Open
    
    ' tbl_Artikel wird berprft ob bereits Testdaten vorhanden sind
    Set RsTemp = Cn.Execute("SELECT COUNT(*) AS Anzahl FROM tbl_Artikel")
    
    If RsTemp("Anzahl").Value = 0 Then
        Load frmCreateExampTables
        frmCreateExampTables.Show
        Call Unload(Me)
    Else
        Load frmMdi
        frmMdi.Show
        Unload Me
    End If
End Sub

' ffnen ber ConnectionString
Private Sub cmdOpenConnString_Click()
Dim sLogin As String
Dim sPassword As String
Dim iAsync As Integer
Dim sConn As String

Me.lstStatus.Clear

If Me.optConnAsync = True Then
    iAsync = adAsyncConnect
Else
    iAsync = -1
End If

Call GetLoginDatas(sLogin, sPassword)

Set CnLocal = Nothing
Set CnLocal = New ADODB.Connection

' ConnectionString wird aufgebaut
sConn = "Provider=Microsoft.Jet.OLEDB.4.0;" & _
        "Data Source=" & App.Path & "\Example_DB.mdb;" & _
        "Jet OLEDB:Database Password=test;"
        
' Wenn System-MDW, dann Parameter bergeben und auf Prompt prfen
If Me.chkSystemMDW.Value = vbChecked Then
    sConn = sConn & "Jet OLEDB:System Database=" & App.Path & "\Example_Secure.mdw;" & _
            "User ID=" & sLogin & ";Password=" & sPassword & ";"
    If Me.optPromptShow.Value = True Then
        sConn = sConn & "Prompt=1"
    Else
        sConn = sConn & "Prompt=4"
    End If
End If

With CnLocal
    .CursorLocation = adUseClient
    .Mode = adModeShareDenyNone
    .Open sConn, , , iAsync
            
    sLogin = .Properties("User ID").Value
    sPassword = .Properties("Password").Value
End With

Call SaveSetting(App.Title, "Main", "Login", sLogin)
' Das Passwort sollte natrlich normalerweise nicht gespeichert werden!
Call SaveSetting(App.Title, "Main", "Password", sPassword)

Me.lstStatus.AddItem "Sub ende"

End Sub

' ffnen mit Parametern
Private Sub cmdOpenParam_Click()
Dim sLogin As String
Dim sPassword As String
Dim iAsync As Integer

Me.lstStatus.Clear

If Me.optConnAsync = True Then
    iAsync = adAsyncConnect
Else
    iAsync = -1
End If

Call GetLoginDatas(sLogin, sPassword)

Set CnLocal = Nothing

Set CnLocal = New ADODB.Connection
    With CnLocal
        .CursorLocation = adUseClient
        .Mode = adModeShareDenyNone
        .Provider = "Microsoft.Jet.OLEDB.4.0"
        .Properties("Data Source") = App.Path & "\Example_DB.mdb"
        ' Datenbankpasswort
        .Properties("Jet OLEDB:Database Password") = "test"
        
        If Me.chkSystemMDW.Value = vbChecked Then
            .Properties("Jet OLEDB:System database") = App.Path & "\Example_Secure.mdw"
            .Properties("User ID") = sLogin '"florianr"
            .Properties("Password") = sPassword '"flo"
            If Me.optPromptShow.Value = True Then
                .Properties("Prompt") = adPromptAlways
            Else
                .Properties("Prompt") = adPromptNever
            End If
        End If
        
        .Open Options:=iAsync
        
        ' Auch mglich, das Passwort und die UserId knnen auch beim Open bergeben werden
        '.Open , sLogin, sPassword, iAsync
        
        ' Userdaten werden in Variable bergeben
        sLogin = .Properties("User ID").Value
        sPassword = .Properties("Password").Value
        
    End With

Call SaveSetting(App.Title, "Main", "Login", sLogin)
' Das Passwort sollte natrlich normalerweise nicht gespeichert werden!
' Wird hier gemacht um jedesmal ein anmelden vor dem Weitergehen zu vermeiden
Call SaveSetting(App.Title, "Main", "Password", sPassword)

Me.lstStatus.AddItem "Sub ende"

End Sub

' ffnen mit einer UDL-Datei
Private Sub cmdOpenUdl_Click()
Dim iAsync As Integer
Dim sMsg As String

Me.lstStatus.Clear

If Me.optConnAsync = True Then
    iAsync = adAsyncConnect
Else
    iAsync = -1
End If

On Error GoTo ErrUDL

Set CnLocal = Nothing
Set CnLocal = New ADODB.Connection

' UDL-Datei wird an Connection bergeben und geffnet
CnLocal.Open "FILE NAME=" & App.Path & "\Example_UDL.udl", , , iAsync
Me.lstStatus.AddItem "Sub Ende"

Exit Sub
ErrUDL:
sMsg = "Fehler: " & Err.Number & vbCrLf & vbCrLf & Err.Description
    ' Prompt ber Fehlerroutine mit einbauen.
    If Me.optPromptShow.Value = True Then
        If Err.Number = -2147217843 Then
            CnLocal.Properties("Prompt") = adPromptCompleteRequired
            CnLocal.Open , , , iAsync
            Resume Next
        End If
    Else
        MsgBox sMsg
    End If
End Sub

' Ende des Verbindungsaufbaus
Private Sub CnLocal_ConnectComplete(ByVal pError As ADODB.Error, adStatus As ADODB.EventStatusEnum, ByVal pConnection As ADODB.Connection)
    If adStatus = adStatusCancel Then               ' Verbindungsaufbau wurde
        Me.lstStatus.AddItem "Connection gecancelt" ' gecanceled (z.B. im Prompt)
    ElseIf adStatus = adStatusErrorsOccurred Then   ' Error
        Me.lstStatus.AddItem "Connection error"
    ElseIf adStatus = adStatusOK Then               ' Verbindung steht
        Me.lstStatus.AddItem "Connection aktiv"
    Else
        Me.lstStatus.AddItem "Anderer Status"       ' Sonstiger Status
    End If
    
    If adStatus = adStatusOK Then   ' Wenn Verbindung steht, dann den Button fr
        Me.cmdGoOn.Enabled = True   ' weiter freigeben
        Me.cmdGoOn.SetFocus
    Else
        Me.cmdGoOn.Enabled = False
    End If
End Sub

Private Sub Form_Load()
Dim sUdl As String
Dim FNr As Integer
Dim sTemp As String
Dim Buffer As String
Dim iPoint As String

sUdl = App.Path & "\Example_UDL.udl"

' Prfen ob die UDL-Datei vorhanden ist
If Dir$(sUdl) = vbNullString Then
    MsgBox "Die Udl-Datei konnte nicht gefunden werden. " & _
            "Diese Methode steht nicht zur Verfgung."
    Me.cmdOpenUdl.Enabled = False
Else
    FNr = FreeFile
    
    Open sUdl For Input As #FNr
        While Not EOF(FNr)
            Line Input #FNr, Buffer
            sTemp = sTemp & Buffer & vbCrLf
        Wend
    Close #FNr
    
    ' Prfen ob in der UDL der Pfad auf die Datenbank und
    ' Sicherheitsdatei im Programmordner gesetzt ist.
    ' Zum testen die Zugangsdaten der UDL-Datei ndern.
    If InStr(1, sTemp, App.Path) = 0 Then
        MsgBox "Bitte starten Sie zuerst die UDL-Datei " & _
                "und ndern sie den Datenbankpfad und den Pfad zur " & _
                "Sicherheits-MDW. " & _
                "Bis dahin ist diese Funktion nicht Verfgbar."
        Me.cmdOpenUdl.Enabled = False
    End If
End If

Me.cmdGoOn.Enabled = False
Me.lstStatus.AddItem "Connection inaktiv"

End Sub

' Userlogin und -passwort werden aus der Registry ausgelesen.
Private Sub GetLoginDatas(ByRef sLogin As String, ByRef sPassword As String)
    sLogin = GetSetting(App.Title, "Main", "Login", vbNullString)
    ' Das Passwort sollte natrlich normalerweise nicht gespeichert werden!
    sPassword = GetSetting(App.Title, "Main", "Password", vbNullString)
End Sub
