VERSION 5.00
Object = "{CDE57A40-8B86-11D0-B3C6-00A0C90AEA82}#1.0#0"; "MSDATGRD.OCX"
Begin VB.Form frmSchemata 
   Caption         =   "Anzeige der bestehenden Datenbankobjekte"
   ClientHeight    =   6645
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   9105
   LinkTopic       =   "Form1"
   MDIChild        =   -1  'True
   ScaleHeight     =   6645
   ScaleWidth      =   9105
   Begin VB.Frame Frame2 
      Caption         =   "Zusatzinformationen"
      Height          =   1215
      Left            =   3000
      TabIndex        =   4
      Top             =   5280
      Width           =   3855
      Begin VB.ComboBox cboInformations 
         Height          =   315
         Left            =   1800
         Style           =   2  'Dropdown List
         TabIndex        =   8
         Top             =   720
         Width           =   1815
      End
      Begin VB.ComboBox cboTables 
         Height          =   315
         Left            =   1800
         Style           =   2  'Dropdown List
         TabIndex        =   6
         Top             =   360
         Width           =   1815
      End
      Begin VB.Label Label2 
         Caption         =   "Informationen:"
         Height          =   255
         Left            =   240
         TabIndex        =   7
         Top             =   720
         Width           =   1455
      End
      Begin VB.Label Label1 
         Caption         =   "Datenbankobjekte:"
         Height          =   255
         Left            =   240
         TabIndex        =   5
         Top             =   360
         Width           =   1455
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   "Datenbankobjekte auslesen"
      Height          =   975
      Left            =   120
      TabIndex        =   2
      Top             =   5280
      Width           =   2655
      Begin VB.ComboBox cboObjects 
         Height          =   315
         Left            =   240
         Style           =   2  'Dropdown List
         TabIndex        =   3
         Top             =   360
         Width           =   2175
      End
   End
   Begin VB.CommandButton cmdClose 
      Caption         =   "Schlieen"
      Height          =   375
      Left            =   7200
      TabIndex        =   1
      Top             =   6120
      Width           =   1815
   End
   Begin MSDataGridLib.DataGrid DataGrid1 
      Align           =   1  'Align Top
      Height          =   5055
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   9105
      _ExtentX        =   16060
      _ExtentY        =   8916
      _Version        =   393216
      AllowUpdate     =   0   'False
      HeadLines       =   1
      RowHeight       =   15
      BeginProperty HeadFont {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ColumnCount     =   2
      BeginProperty Column00 
         DataField       =   ""
         Caption         =   ""
         BeginProperty DataFormat {6D835690-900B-11D0-9484-00A0C91110ED} 
            Type            =   0
            Format          =   ""
            HaveTrueFalseNull=   0
            FirstDayOfWeek  =   0
            FirstWeekOfYear =   0
            LCID            =   1031
            SubFormatType   =   0
         EndProperty
      EndProperty
      BeginProperty Column01 
         DataField       =   ""
         Caption         =   ""
         BeginProperty DataFormat {6D835690-900B-11D0-9484-00A0C91110ED} 
            Type            =   0
            Format          =   ""
            HaveTrueFalseNull=   0
            FirstDayOfWeek  =   0
            FirstWeekOfYear =   0
            LCID            =   1031
            SubFormatType   =   0
         EndProperty
      EndProperty
      SplitCount      =   1
      BeginProperty Split0 
         BeginProperty Column00 
         EndProperty
         BeginProperty Column01 
         EndProperty
      EndProperty
   End
End
Attribute VB_Name = "frmSchemata"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit


Private Sub cboInformations_Click()
Dim vRestrictions As Variant    ' Fr eventuelle Begrenzungen
Dim SE As SchemaEnum            ' Variable fr aufzurufendes Schema


Select Case Me.cboInformations.ListIndex    ' Welche Informationen sollen gezogen werden
    Case 0
        SE = adSchemaColumns                ' Spalten anzeigen
        
        ' Alle oder nur von einer bestimmten Tabelle
        If Me.cboTables.Text <> "<ALLE>" Then
            vRestrictions = Array(Empty, Empty, Me.cboTables.Text)
        End If
    Case 1
        SE = adSchemaIndexes                ' Indizes anzeigen
        
        If Me.cboTables.Text <> "<ALLE>" Then
            vRestrictions = Array(Empty, Empty, Empty, Empty, Me.cboTables.Text)
        End If
    Case 2
        SE = adSchemaPrimaryKeys            ' Primarschlssel anzeigen
        
        If Me.cboTables.Text <> "<ALLE>" Then
            vRestrictions = Array(Empty, Empty, Me.cboTables.Text)
        End If
    Case 3
        SE = adSchemaForeignKeys            ' Fremdschlssel anzeigen
        
        If Me.cboTables.Text <> "<ALLE>" Then
            vRestrictions = Array(Empty, Empty, Me.cboTables.Text)
        End If
    Case 4
        SE = adSchemaReferentialConstraints ' Verknpfungen anzeigen
    Case 5
        SE = adSchemaKeyColumnUsage         ' Alle Schlssel anzeigen
End Select

Set Me.DataGrid1.DataSource = Cn.OpenSchema(SE, vRestrictions)  ' Anzeige in Grid

End Sub

Private Sub cboObjects_Click()
Dim SE As ADODB.SchemaEnum

Select Case Me.cboObjects.ListIndex
    Case 0  ' Tabellen (und Abfragen) anzeigen
        SE = adSchemaTables
    Case 1  ' Views (Abfragen) anzeigen
        SE = adSchemaViews
    Case 2  ' StoredProcedures anzeigen
        SE = adSchemaProcedures
End Select

Set Me.DataGrid1.DataSource = Cn.OpenSchema(SE) ' Anzeige in Grid

End Sub

Private Sub cmdClose_Click()
    Unload Me
End Sub

Private Sub Form_Load()
Dim i As Integer
Dim RsTemp As ADODB.Recordset

    With Me
        With .cboObjects    ' Hauptobjekte in ComboBox
            .AddItem "Tabellen"
            .AddItem "Views"
            .AddItem "StoredProcedures"
            .ListIndex = 0
        End With
        
        Set RsTemp = Cn.OpenSchema(adSchemaTables)  ' Tabellen auslesen
            
        With .cboTables
            .AddItem "<ALLE>"
            
            For i = 0 To RsTemp.RecordCount - 1 ' Alle Tabellennamen in ComboBox
                .AddItem RsTemp.Fields("TABLE_NAME").Value
                RsTemp.MoveNext
            Next i
            
            .ListIndex = 0
        End With
        
        With .cboInformations   ' Auswahlmglichkeiten fr Zusatzinformationen
            .AddItem "Spalten"
            .AddItem "Indizes"
            .AddItem "PrimatyKeys"
            .AddItem "ForeignKeys"
            .AddItem "Constraints"
            .AddItem "KeyUsage"
        End With
        
        .Height = 7050
        .Left = 0
        .Width = frmMdi.ScaleWidth
        .Top = 0
    End With
    
End Sub

