VERSION 5.00
Begin VB.Form frmPageProp 
   Caption         =   "Arbeiten mit den Page-Eigenschaften"
   ClientHeight    =   5025
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   8130
   LinkTopic       =   "Form1"
   MDIChild        =   -1  'True
   ScaleHeight     =   5025
   ScaleWidth      =   8130
   Begin VB.CommandButton cmdNext 
      Caption         =   "Nchste"
      Height          =   375
      Left            =   1320
      TabIndex        =   2
      Top             =   960
      Width           =   1215
   End
   Begin VB.CommandButton cmdPrevious 
      Caption         =   "Vorherige"
      Height          =   375
      Left            =   120
      TabIndex        =   1
      Top             =   960
      Width           =   1215
   End
   Begin VB.Line Line2 
      X1              =   0
      X2              =   8000
      Y1              =   1410
      Y2              =   1410
   End
   Begin VB.Line Line1 
      X1              =   0
      X2              =   8000
      Y1              =   1440
      Y2              =   1440
   End
   Begin VB.Label lblInfo 
      Caption         =   $"frmPageProp.frx":0000
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H000000FF&
      Height          =   615
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   7695
   End
End
Attribute VB_Name = "frmPageProp"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim WithEvents Rs As ADODB.Recordset
Attribute Rs.VB_VarHelpID = -1

' Zur nchsten Seite gehen
Private Sub cmdNext_Click()
    Rs.AbsolutePage = Rs.AbsolutePage + 1
    PrintList
End Sub

' Zur vorherigen Seite gehen
Private Sub cmdPrevious_Click()
    Rs.AbsolutePage = Rs.AbsolutePage - 1
    PrintList
End Sub

Private Sub Form_Load()

Set Rs = New ADODB.Recordset    ' Alle Lieferanten werden ausgelesen
    With Rs
        .ActiveConnection = Cn
        .CursorLocation = adUseClient
        .CursorType = adOpenKeyset
        .LockType = adLockReadOnly
        .Source = "SELECT * FROM tbl_Lieferanten"
        .Open
        
        .PageSize = 20  ' Seitenzahl wird auf 20 gesetzt
    End With
    
With Me ' Formular wird formatiert
'    .FontName = "Courier New"
    .AutoRedraw = True      ' Auf Form geschriebene Daten halten
    .BackColor = &HFFFFFF
    .lblInfo.BackColor = &HFFFFFF
    .Width = 9000
    .Height = 9000
End With

PrintList

End Sub

' Ausdruckbeispiel wird auf Formular geschrieben
Private Sub PrintList()
Dim i As Integer
Dim j As Integer
Dim sTemp As String ' Buffer fr Textausgabe
Dim Sp(5) As Long   ' Spaltenbreiten
Dim iStart As Long  ' Startposition fr Tabelle
Dim iPage As Long   ' Merker fr Seitenposition

Me.Cls
Me.CurrentY = Me.Line1.y1 + 600

' Spaltenbreiten setzen
Sp(0) = 0
Sp(1) = 750
Sp(2) = 3300
Sp(3) = 5700
Sp(4) = 6450
Sp(5) = 7200

With Rs
    Me.FontBold = True
    Me.FontUnderline = True
    Me.Print "Liste aller Lieferanten"
    Me.Print
    Me.FontUnderline = False
    Me.FontBold = False
    
    iStart = Me.CurrentY
    
    Me.CurrentX = Sp(0) ' Spaltenberschriften setzen
    Me.Print "Nummer";
    Me.CurrentX = Sp(1)
    Me.Print "Name";
    Me.CurrentX = Sp(2)
    Me.Print "Strasse";
    Me.CurrentX = Sp(3)
    Me.Print "HausNr";
    Me.CurrentX = Sp(4)
    Me.Print "PLZ";
    Me.CurrentX = Sp(5)
    Me.Print "Ort";
    
    Me.CurrentY = Me.CurrentY + 300
    Me.Line (0, Me.CurrentY)-(Me.ScaleWidth, Me.CurrentY)
    Me.Print
    
    iPage = .AbsolutePage   ' aktuelle Seite merken
    
    For i = 0 To .PageSize - 1  ' Alle Werte der aktuellen Seite durchlaufen
        For j = 0 To .Fields.Count - 1  ' Alle Spalten des aktuellen
                                        ' Datensatzes durchlaufen
            Me.CurrentX = Sp(j) ' Spaltenbeginn setzen
            If j <> .Fields.Count - 1 Then
                ' Wenn nicht die Letze Spalte dann Spaltenbreite ber Startposition
                ' der nchsten Spalte berechnen
                sTemp = FormatText(.Fields(j).Value, Sp(j + 1) - Sp(j))
            Else
                ' Wenn letzte Spalte, dann bis Formularende
                sTemp = FormatText(.Fields(j).Value, Me.ScaleWidth - Sp(j))
            End If
            Me.Print sTemp; ' Textausgabe
        Next j
        Me.Print
        
        .MoveNext   ' Nchster Datensatz
        If .EOF = True Then Exit For    ' Wenn am Ende (letzte Seite mglich),
                                        ' dann Schleife beenden
    Next i
    
    .AbsolutePage = iPage   ' Seite wieder setzen, da durch das letzte MoveNext
                            ' die nchste Seite erreicht wurde
    
    For i = 0 To UBound(Sp) ' Senkrechte Linien zwischen die Spalten
        Me.Line (Sp(i), iStart)-(Sp(i), Me.CurrentY)
    Next i
    
    ' Linie unter die Tabelle zeichnen
    Me.Line (0, Me.CurrentY)-(Me.ScaleWidth, Me.CurrentY)
    
    Me.Print
    Me.FontBold = True
    ' Aktuelle Seite ausgeben
    Me.Print "Seite " & .AbsolutePage & " von " & .PageCount
    Me.FontBold = False
    
    If .AbsolutePage = 1 Then           ' Wenn erste Seite, dann cmdPrevios sperren
        Me.cmdPrevious.Enabled = False
        Me.cmdNext.Enabled = True
    ElseIf .AbsolutePage = .PageCount Then  ' Wenn letzte, dann cmdNext sperren
        Me.cmdNext.Enabled = False
        Me.cmdPrevious.Enabled = True
    Else
        Me.cmdNext.Enabled = True
        Me.cmdPrevious.Enabled = True
    End If
End With

End Sub

' Maximale Lnge des auszugebenden Textes ermitteln.
' In der Praxis ist dies hier natrlich nicht machbar, man knnte z.B.
' In Blockform den Ausgabetext untereinander setzen.
' Fr ein Beispiel war das jedoch ausreichend
Private Function FormatText(sText As String, ByVal iWidth As Long) As String
Dim sTemp As String
Dim i As Long

iWidth = iWidth - 60    ' Rechts ein bichen Platz lassen

If Me.TextWidth(sText) <= iWidth Then   ' Wenn Text krzer als maximal mglich,
    FormatText = sText                  ' dann 1:1 zurckgeben
    Exit Function
End If
    
    Do      ' Bis maximale Lnge berschritten immer einen Buchstaben anhngen
        i = i + 1
        sTemp = Left(sText, i)
    Loop Until Me.TextWidth(sTemp) > iWidth
    
    sTemp = Right(sTemp, Len(sTemp) - 1)    ' Letzten Buchstaben lschen
    
FormatText = sTemp  ' Formatierten Text zurckgeben

End Function



