VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form frmStream 
   Caption         =   "Arbeiten mit dem Stream-Objekt"
   ClientHeight    =   5730
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   8340
   LinkTopic       =   "Form1"
   MDIChild        =   -1  'True
   ScaleHeight     =   5730
   ScaleWidth      =   8340
   Begin VB.CommandButton cmdImport 
      Caption         =   "Neues Bild einlesen"
      Height          =   375
      Left            =   4440
      TabIndex        =   9
      Top             =   5040
      Width           =   1800
   End
   Begin VB.CommandButton cmdExport 
      Caption         =   "Bild exportieren"
      Height          =   375
      Left            =   4440
      TabIndex        =   8
      Top             =   4680
      Width           =   1800
   End
   Begin MSComDlg.CommonDialog cdlMain 
      Left            =   2640
      Top             =   4440
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.TextBox txtId 
      Height          =   285
      Left            =   1200
      TabIndex        =   5
      Top             =   240
      Width           =   1575
   End
   Begin VB.PictureBox Picture1 
      Height          =   3375
      Left            =   240
      ScaleHeight     =   3315
      ScaleWidth      =   7755
      TabIndex        =   4
      Top             =   960
      Width           =   7815
   End
   Begin VB.CommandButton cmdNavigate 
      Caption         =   "|<"
      Height          =   375
      Index           =   0
      Left            =   240
      TabIndex        =   3
      Top             =   5040
      Width           =   735
   End
   Begin VB.CommandButton cmdNavigate 
      Caption         =   "<<"
      Height          =   375
      Index           =   1
      Left            =   960
      TabIndex        =   2
      Top             =   5040
      Width           =   735
   End
   Begin VB.CommandButton cmdNavigate 
      Caption         =   ">>"
      Height          =   375
      Index           =   2
      Left            =   1680
      TabIndex        =   1
      Top             =   5040
      Width           =   735
   End
   Begin VB.CommandButton cmdNavigate 
      Caption         =   ">|"
      Height          =   375
      Index           =   3
      Left            =   2400
      TabIndex        =   0
      Top             =   5040
      Width           =   735
   End
   Begin VB.Label Label2 
      Caption         =   "Bild:"
      Height          =   255
      Left            =   240
      TabIndex        =   7
      Top             =   720
      Width           =   1095
   End
   Begin VB.Label Label1 
      Caption         =   "Bildindex:"
      Height          =   255
      Left            =   240
      TabIndex        =   6
      Top             =   240
      Width           =   855
   End
End
Attribute VB_Name = "frmStream"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim Rs As ADODB.Recordset
Dim sTempFile As String     ' Pfad fr temporre Datei

Private Sub GetValues()
Dim Strm As ADODB.Stream

Set Strm = New ADODB.Stream ' Streamobjekt wird initialisiert
Strm.Type = adTypeBinary    ' Typ auf Binrdaten setzen
Strm.Open                   ' Stream wird geffnet
Strm.Write Rs.Fields("Ole_Picture").Value ' Daten werden aus Rs in Stream geschrieben
' Datei wird temporr gespeichert bestehende Datei wird berschrieben
Strm.SaveToFile sTempFile, adSaveCreateOverWrite
                                                    

With Me ' Bild wird aus temporrer Datei eingelesen und Id angezeigt
    Me.Picture1.Picture = LoadPicture(sTempFile)
    Me.txtId.Text = Rs.Fields("Ole_Id")
End With

End Sub

Private Sub cmdExport_Click()
Dim Strm As ADODB.Stream
Dim sFile As String

On Error GoTo ErrExport

With Me.cdlMain ' Pfad fr Datei wird abgefragt
    .DialogTitle = "Bild exportieren..."
    .ShowSave
    sFile = .FileName
End With

Set Strm = New ADODB.Stream
    With Strm
        .Type = adTypeBinary
        .Open
        .Write Rs.Fields("Ole_Picture") ' Bild wird aus Rs in Stream geschrieben
        .SaveToFile sFile, adSaveCreateOverWrite    ' Bild wird in Datei gespeichert
    End With
    
Exit Sub

ErrExport:
If Err.Number <> 32755 Then
    MsgBox Err.Description
End If

End Sub

Private Sub cmdImport_Click()
Dim Strm As ADODB.Stream
Dim sFile As String

On Error GoTo ErrImport

With Me.cdlMain     ' Datei wird abgefragt
    .DialogTitle = "Bild einlesen..."
    .ShowOpen
    sFile = .FileName
End With

Set Strm = New ADODB.Stream
    With Strm
        .Type = adTypeBinary
        .Open
        .LoadFromFile sFile ' Stream wird aus Datei eingelesen
    End With
    
    With Rs
        .AddNew     ' Neuer Datensatz wird angelegt
        .Fields("Ole_Picture") = Strm.Read  ' Bild wird aus Stream gelesen
        .Update     ' Daten werden gespeichert
        .MoveFirst
    End With

Exit Sub

ErrImport:
If Err.Number <> 32755 Then
    MsgBox Err.Description
End If

End Sub

' Datensatznavigation (siehe frmNavigate)
Private Sub cmdNavigate_Click(Index As Integer)
    With Rs
        Select Case Index
            Case 0
                .MoveFirst
            Case 1
                If .AbsolutePosition = 1 Then
                    .MoveLast
                Else
                    .MovePrevious
                End If
            Case 2
                If .AbsolutePosition = .RecordCount Then
                    .MoveFirst
                Else
                    .MoveNext
                End If
            Case 3
                .MoveLast
        End Select
    End With
    
    Call GetValues
    
End Sub

Private Sub Form_Load()
Dim Strm As ADODB.Stream

Set Rs = New ADODB.Recordset    ' Daten werden aus Tabelle fr Binrdaten gelesen
    With Rs
        .ActiveConnection = Cn
        .CursorLocation = adUseClient
        .CursorType = adOpenKeyset
        .LockType = adLockOptimistic
        .Source = "SELECT * FROM tbl_Ole"
        .Open
    End With

If Rs.RecordCount = 0 Then  ' Wenn keine Daten vorhanden wird das mitgelieferte
    Set Strm = New ADODB.Stream ' Bild eingelesen um ein Beispielbild zu erhalten
        With Strm
            .Type = adTypeBinary    ' Binrformat
            .Open                   ' Stream ffnen
            .LoadFromFile App.Path & "\Island.jpg"  ' Bild aus Datei einlesen
            
            Rs.AddNew                           ' Datensatz anlegen
            Rs.Fields("Ole_Picture") = .Read    ' Bild aus Stream lesen
            Rs.Update                           ' Daten werden gespeichert
            Rs.Requery
            Rs.MoveFirst
        End With
End If

With Me.cdlMain ' CommonDialog wird fr jpgs und bmps vordefiniert
    .DefaultExt = ".jpg"
    .Filter = "Bilder *.jpg;*.bmp|*.jpg;*.bmp"
    .CancelError = True ' Bei "Abbrechen" wird Fehler 32755 ausgelst
End With

sTempFile = App.Path & "\~pic.tmp"  ' Pfad fr Temporre Datei

GetValues

End Sub

Private Sub Form_Unload(Cancel As Integer)

If Dir$(sTempFile) <> vbNullString Then ' Temporre Datei wird gelscht
    Kill sTempFile
End If

End Sub
